"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.mockImport = void 0;
/**
 * Implementation of the mockImport method
 * @module
 */
const stack = __importStar(require("@tapjs/stack"));
const path_1 = require("path");
const url_1 = require("url");
const crypto_1 = require("crypto");
const builtin_set_1 = require("resolve-import/builtin-set");
const is_relative_require_1 = require("resolve-import/is-relative-require");
const loader_url_js_1 = require("./loader-url.js");
const loaderSymbol = Symbol.for('__tapmockLoader');
// turn all the mocks we get into either the exports provided,
// if it's an object, or { default: <value> } otherwise.
const mungeMocks = (mocksInput, dir) => {
    const mocks = Object.create(null);
    for (const [k, v] of Object.entries(mocksInput)) {
        const m = v && typeof v === 'object' ? v : { default: v };
        if (builtin_set_1.builtinSet.has(k)) {
            mocks[k] = m;
            if (k.startsWith('node:')) {
                const bare = k.substring('node:'.length);
                if (!(bare in mocksInput)) {
                    mocks[bare] = m;
                }
            }
            else {
                const prefixed = `node:${k}`;
                if (!(prefixed in mocksInput)) {
                    mocks[prefixed] = m;
                }
            }
        }
        else if (/^(file:\/\/\/|https?:\/\/)/.test(k)) {
            mocks[k] = m;
        }
        else if ((0, is_relative_require_1.isRelativeRequire)(k) || (0, path_1.isAbsolute)(k)) {
            mocks[String((0, url_1.pathToFileURL)((0, path_1.resolve)(dir, k)))] = m;
        }
        else {
            // absolute package name
            mocks[k] = m;
        }
    }
    return mocks;
};
/**
 * Function that performs a mock `import()`
 *
 * Returns a function that returns the mock key string, and method that
 * loads the asynchronous function that will load the module and return
 * a Promise to its exports.
 */
const mockImport = (module, mocks = {}, caller = exports.mockImport) => {
    const needIgnoreTap = !stack.getIgnoredPackages().includes('@tapjs');
    if (needIgnoreTap)
        stack.addIgnoredPackage('@tapjs');
    const at = stack.at(caller);
    if (needIgnoreTap)
        stack.removeIgnoredPackage('@tapjs');
    const path = at?.absoluteFileName;
    if (!path) {
        throw new Error('could not get current call site');
    }
    const dir = (0, path_1.dirname)(path);
    const url = (0, url_1.pathToFileURL)(path);
    // TODO this shouldn't be a restriction, actually. I can just use
    // different keys for each @tapjs/mock module in play
    // It's intentionally very impossible to change once set, so it won't
    // actually get to this point, and will throw earlier if it's a problem
    /* c8 ignore start */
    if (global[loaderSymbol] !== loader_url_js_1.loaderURL) {
        const msg = `Cannot mock ESM. Run with --loader=@tapjs/mock/loader to enable. (Are multiple @tapjs/mock modules in use?)`;
        const er = Object.assign(new Error(msg), {
            found: global.__tapmockLoader,
            wanted: loader_url_js_1.loaderURL,
        });
        Error.captureStackTrace(er, caller);
        throw er;
    }
    /* c8 ignore stop */
    const key = (0, crypto_1.randomBytes)(8).toString('hex');
    mocks = mungeMocks(mocks, dir);
    const m = {
        mocks,
        unmock: () => {
            m.mocks = mocks = undefined;
        },
        key,
        caller: {
            path,
            dir,
            url,
            at,
            stack: stack.captureString(caller),
        },
    };
    Object.defineProperty(global, `__tapmock${key}`, {
        value: m,
        enumerable: false,
        configurable: false,
        writable: false,
    });
    const start = new URL(module, url);
    start.searchParams.set('tapmock', key);
    return [key, () => import(`${start}`)];
};
exports.mockImport = mockImport;
//# sourceMappingURL=mock-import.js.map